/*
 * 쐬: 2005/06/16
 * Member DAO NX
 */
package diaop.dao;

import java.io.Serializable;
import java.util.*;

import diaop.model.*;
import diaop.util.*;

/**
 * MemberDao
 *
 * @author Hiroshi TAKEMOTO
 */
public class DbUnitMemberDao extends HibernateMemberDao 
implements ILoadAndSave, IDbUnitAware {
	private DbHelper[]	dbHelpers = {
		new DbHelper(Member.class)
	};
	private Map		helperMap;
	
	public DbUnitMemberDao() {
		super();
		helperMap = new HashMap();
		for (int i = 0; i < dbHelpers.length; i++) {
			helperMap.put(dbHelpers[i].getClsName(), dbHelpers[i]);
		}
	}
	public void delete(Class cls, String where) {
		String hql = "from " + cls.getName() + " " + where;
		template.delete(hql);
	}
	public Map getHelperMap() {
		return helperMap;
	}
	public List loadAll(Class cls) {
		return (template.loadAll(cls));
	}
	public Serializable save(Object obj) {
		return (template.save(obj));
	}
	public void flush() {
		template.flush();
	}
	public void dump(String path) {
		DbUnitHelper dbUnit = new DbUnitHelper(this);
		dbUnit.dump(path);
	}	
	public void restore(String path) {
		DbUnitHelper dbUnit = new DbUnitHelper(this);
		dbUnit.restore(path);
	}				
}
