/*
 * 쐬: 2005/06/21
 *
 * DbUnit`łcadump/restores[eBeB
 */
package diaop.util;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.digester.Digester;

/**
 * DbUnitHelper
 *
 * @author Hiroshi TAKEMOTO
 */
public class DbUnitHelper {
	private ILoadAndSave	dao;
	private Digester 		digester;

	public DbUnitHelper(ILoadAndSave dao) {
		this.dao = dao;
		setupDigester();
	}

	public void dump(Writer writer) {	
		try {
			Iterator itr = dao.getHelperMap().values().iterator();	
			writer.write("<?xml version=\"1.0\" encoding=\"Windows-31J\"?>\n");
			writer.write("<dataset>\n")	;	
			// ee[uɑ΂
			while (itr.hasNext()) {
				DbHelper helper = (DbHelper) itr.next();
				List list = dao.loadAll(Class.forName(helper.getClsName()));
				if (list != null) {
					for (int i = 0; i < list.size(); i++) {
						writer.write(helper.toDbUnitFormat(list.get(i)));
					}
				}
			}
			writer.write("</dataset>\n");
			writer.close();		
		}
		catch (Exception e){}
	}
	
	public void dump(String path) {
		try {
			OutputStreamWriter writer = 
				new OutputStreamWriter(new FileOutputStream(path));
			dump(writer);
		}
		catch (Exception e) {
		}
	}
	
	public void restore(String path) {
		try {
			BufferedInputStream	stream = 
				new BufferedInputStream(new FileInputStream(path));
			Iterator itr = dao.getHelperMap().values().iterator();
			
			// ׂẴe[uɂ
			while (itr.hasNext()) {
				DbHelper helper = (DbHelper) itr.next();
				dao.delete(Class.forName(helper.getClsName()), "");
			}
			dao.flush();
			
			List dataset = (List)digester.parse(stream);
			if (dataset != null) {
				for (int i = 0; i < dataset.size(); i++) {
					dao.save(dataset.get(i));
				}
			}			
		}
		catch (Exception e) {}
	}
	
	private Digester setupDigester() {
		digester = new Digester();
		// <dataset>^Ȍ
		digester.addObjectCreate("dataset", "java.util.ArrayList");
		digester.addSetProperties("dataset");
		
		Iterator itr = dao.getHelperMap().values().iterator();
		while (itr.hasNext()) {
			DbHelper helper = (DbHelper) itr.next();
			digester.addObjectCreate("dataset/" + helper.getTableName(), 
										helper.getClsName(), "type");		
			digester.addSetNext("dataset/" + helper.getTableName(), "add",
										helper.getClsName());
			digester.addSetProperties("dataset/" + helper.getTableName());					
		}		
		return (digester);
	}
}

